-- lighting control applet 
module(...,package.seeall)
require("xap")
require("xap.bsc")
require("string")
info={
   version="1.1", description="Dimmable lighting control - Lounge 1"
   }
--This is an even address so use even dim suffix list
local dimprefix = "010200FA09C400FA00FA00FA044C00FA00000C0127104A1999999A5999A5A5A599A659A59965A5"
local offstream = "010200FA09C400FA00FA00FA044C00FA00000C012710421999999A5999A5A5A599A659A599A5A580"
local onstream = "010200FA09C400FA00FA00FA044C00FA00000C012710421999999A5999A5A5A599A659A59A65A580"
local dimsuffix = {
"999A40",
"99A580",
"99A640",
"9A5980",
"9A5A40",
"9A6580",
"9A6640",
"A59980",
"A59A40",
"A5A580",
"A5A640",
"A65980",
"A65A40",
"A66580",
"A66640",
}

function levelcontrol(endpoint)
--	print("Lounge1")
	dimLevel = xap.getValue("output.state.1","level") -- value received 0 - 150
	dimsetting = math.floor((dimLevel/10)+0.5) -- set display text to be between 0-15
--	print(dimLevel)
--	print(dimsetting)
	if dimsetting == 0 then -- if state is off send off stream
      		sendcmd(offstream)
      		updateRFstate("off") -- This bit updates my RF state so if a dim level of 0 is set the RF shows as off
--     	elseif dimsetting == 15 then -- if level is 100% send on string
--        	sendcmd(onstream)
        else
          	dimstream = dimprefix..dimsuffix[tonumber(dimsetting)]
           	sendcmd(dimstream)
           	updateRFstate("on") -- This bit updates my RF state so if a dim level >0 is set the RF shows as on
--		print(dimsuffix[tonumber(dimsetting)])
        end
end

function sendcmd(data)
	msg = string.format([[xap-header
        	{
             		v=12
             		hop=1
             		uid=FF00EE00
             		class=rf.xmit
             		source=dbzoo.fake.source
             		target=dbzoo.livebox.Controller
             	}
         rf
             	{
             		data=%s
             	}]], data)
          xap.sendShort(msg)
end

-- This bit updates my RF state so if a dim level is set the RF shows as on
function updateRFstate(rfstate)
	msg = string.format([[xap-header
		{
			v=12
			hop=1
			uid=FF00DBB0
			class=xAPBSC.event
			source=dbzoo.livebox.Controller:rf.17
		}
	output.state
		{
			state=%s
			displaytext=Lounge Light 1 %s
		}]], rfstate, rfstate)
	xap.sendShort(msg)
end

function init()
	bsc.Endpoint{source="dbzoo.livebox.LightingControl:LoungeLights1", direction=bsc.OUTPUT, type=bsc.LEVEL, cmdCB=levelcontrol}
--	print("Endpoint set up") 
	local f = xap.Filter()
	f:add("xap-header", "target", "dbzoo.livebox.LightingControl:LoungeLights1")
	f:add("xap-header","class","xAPBSC.cmd")
	f:callback(levelcontrol)
--	print("Filters set up")
end
               
